<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__retarget__io_8h" kind="file" language="C++">
    <compoundname>cy_retarget_io.h</compoundname>
    <includes local="no">stdio.h</includes>
    <includes local="yes">cy_result.h</includes>
    <includes local="yes">cyhal_hw_types.h</includes>
    <includedby local="yes" refid="cy__retarget__io_8c">cy_retarget_io.c</includedby>
    <incdepgraph>
      <node id="9">
        <label>cy_result.h</label>
      </node>
      <node id="10">
        <label>cyhal_hw_types.h</label>
      </node>
      <node id="7">
        <label>cy_retarget_io.h</label>
        <link refid="cy__retarget__io_8h" />
        <childnode refid="8" relation="include">
        </childnode>
        <childnode refid="9" relation="include">
        </childnode>
        <childnode refid="10" relation="include">
        </childnode>
      </node>
      <node id="8">
        <label>stdio.h</label>
      </node>
    </incdepgraph>
      <sectiondef kind="define">
      <memberdef id="group__group__board__libs_1gabb0b30d1e6a6c7e301b2b74450be762d" kind="define" prot="public" static="no">
        <name>CY_RETARGET_IO_BAUDRATE</name>
        <initializer>(115200)</initializer>
        <briefdescription>
<para>UART baud rate. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_RETARGET_IO/retarget-io/cy_retarget_io.h" bodystart="52" column="9" file="output/libs/COMPONENT_RETARGET_IO/retarget-io/cy_retarget_io.h" line="52" />
      </memberdef>
      <memberdef id="group__group__board__libs_1ga8412e89ceaeefb3ab3d75509ab99680b" kind="define" prot="public" static="no">
        <name>CY_RETARGET_IO_CONVERT_LF_TO_CRLF</name>
        <briefdescription>
<para>Defining this macro enables conversion of line feed (LF) into carriage return followed by line feed (CR &amp; LF) on the output direction (STDOUT). </para>        </briefdescription>
        <detaileddescription>
<para>You can define this macro through the DEFINES variable in the application Makefile. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_RETARGET_IO/retarget-io/cy_retarget_io.h" bodystart="61" column="9" file="output/libs/COMPONENT_RETARGET_IO/retarget-io/cy_retarget_io.h" line="61" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="var">
      <memberdef id="group__group__board__libs_1gacde12f44b3729c38a0aa85f7679054c9" kind="variable" mutable="no" prot="public" static="no">
        <type>cyhal_uart_t</type>
        <definition>cyhal_uart_t cy_retarget_io_uart_obj</definition>
        <argsstring />
        <name>cy_retarget_io_uart_obj</name>
        <briefdescription>
<para>UART HAL object used by this library. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_RETARGET_IO/retarget-io/cy_retarget_io.c" bodystart="98" column="1" file="output/libs/COMPONENT_RETARGET_IO/retarget-io/cy_retarget_io.h" line="49" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__board__libs_1ga21265301bf6e9239845227c2aead9293" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_retarget_io_init</definition>
        <argsstring>(cyhal_gpio_t tx, cyhal_gpio_t rx, uint32_t baudrate)</argsstring>
        <name>cy_retarget_io_init</name>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>tx</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>rx</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>baudrate</declname>
        </param>
        <briefdescription>
<para>Initialization function for redirecting low level IO commands to allow sending messages over a UART interface. </para>        </briefdescription>
        <detaileddescription>
<para>This will setup the communication interface to allow using printf and related functions. <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>tx</parametername>
</parameternamelist>
<parameterdescription>
<para>UART TX pin </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>rx</parametername>
</parameternamelist>
<parameterdescription>
<para>UART RX pin </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>baudrate</parametername>
</parameternamelist>
<parameterdescription>
<para>UART baudrate </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if successfully initialized, else an error about what went wrong </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="368" bodyfile="output/libs/COMPONENT_RETARGET_IO/retarget-io/cy_retarget_io.c" bodystart="344" column="1" file="output/libs/COMPONENT_RETARGET_IO/retarget-io/cy_retarget_io.h" line="75" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1gaa3ec2f7eab2ff27d716f2b22d90ff514" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cy_retarget_io_deinit</definition>
        <argsstring>(void)</argsstring>
        <name>cy_retarget_io_deinit</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Releases the UART interface allowing it to be used for other purposes. </para>        </briefdescription>
        <detaileddescription>
<para>After calling this, printf and related functions will no longer work. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="373" bodyfile="output/libs/COMPONENT_RETARGET_IO/retarget-io/cy_retarget_io.c" bodystart="370" column="1" file="output/libs/COMPONENT_RETARGET_IO/retarget-io/cy_retarget_io.h" line="81" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Provides APIs for transmitting messages to or from the board via standard printf/scanf functions. </para>    </briefdescription>
    <detaileddescription>
<para>Messages are transmitted over a UART connection which is generally connected to a host machine. Transmission is done at 115200 baud using the tx and rx pins provided by the user of this library. The UART instance is made available via cy_retarget_io_uart_obj in case any changes to the default configuration are desired. NOTE: If the application is built using newlib-nano, by default, floating point format strings (f) are not supported. To enable this support you must add '-u _printf_float' to the linker command line.</para><para><simplesect kind="copyright"><para>Copyright 2018-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para></simplesect>
Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="38"><highlight class="preprocessor">#pragma<sp />once</highlight><highlight class="normal" /></codeline>
<codeline lineno="39"><highlight class="normal" /></codeline>
<codeline lineno="40"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;stdio.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="41"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_result.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="42"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_hw_types.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="43"><highlight class="normal" /></codeline>
<codeline lineno="44"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="45"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="46"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="47"><highlight class="normal" /></codeline>
<codeline lineno="49"><highlight class="keyword">extern</highlight><highlight class="normal"><sp />cyhal_uart_t<sp /><ref kindref="member" refid="group__group__board__libs_1gacde12f44b3729c38a0aa85f7679054c9">cy_retarget_io_uart_obj</ref>;</highlight></codeline>
<codeline lineno="50"><highlight class="normal" /></codeline>
<codeline lineno="52"><highlight class="preprocessor">#define<sp />CY_RETARGET_IO_BAUDRATE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(115200)</highlight><highlight class="normal" /></codeline>
<codeline lineno="53"><highlight class="normal" /></codeline>
<codeline lineno="54"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />DOXYGEN</highlight><highlight class="normal" /></codeline>
<codeline lineno="55"><highlight class="normal" /></codeline>
<codeline lineno="61"><highlight class="preprocessor">#define<sp />CY_RETARGET_IO_CONVERT_LF_TO_CRLF</highlight><highlight class="normal" /></codeline>
<codeline lineno="62"><highlight class="normal" /></codeline>
<codeline lineno="63"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />DOXYGEN<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="64"><highlight class="normal" /></codeline>
<codeline lineno="75"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1ga21265301bf6e9239845227c2aead9293">cy_retarget_io_init</ref>(cyhal_gpio_t<sp />tx,<sp />cyhal_gpio_t<sp />rx,<sp />uint32_t<sp />baudrate);</highlight></codeline>
<codeline lineno="76"><highlight class="normal" /></codeline>
<codeline lineno="81"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__board__libs_1gaa3ec2f7eab2ff27d716f2b22d90ff514">cy_retarget_io_deinit</ref>(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="82"><highlight class="normal" /></codeline>
<codeline lineno="83"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="84"><highlight class="normal">}</highlight></codeline>
<codeline lineno="85"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="86"><highlight class="normal" /></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_RETARGET_IO/retarget-io/cy_retarget_io.h" />
  </compounddef>
</doxygen>